#include <time.h>
#include <stdio.h>
#include "det.h"

long long nanoseconds(void)
{
  struct timespec ts;
  clock_gettime(CLOCK_MONOTONIC,&ts);
  return ts.tv_nsec+ts.tv_sec*(long long) 1000000000;
}

int main()
{
  mpz_t det;
  mpz_init(det);
  mpz_t f[1024];
  for (long long i = 0;i < 1024;++i)
    mpz_init(f[i]);

  mpz_set_si(f[0],3);
  mpz_set_si(f[271],1);
  mpz_set_si(f[828],4);

  for (long long loop = 0;loop < 10;++loop) {
    long long t0 = nanoseconds();
    cyclo2power_det_signed(det,f,1024);
    long long t1 = nanoseconds();
  
    printf("%lld ns\n",t1-t0);
  }

  mpz_out_str(stdout,10,det);
  printf("\n");

  mpz_clear(det);
  for (long long i = 0;i < 1024;++i)
    mpz_clear(f[i]);
  
  return 0;
}
